/* *************************************************************
   RWhois Software

   Copyright (c) 1994 Scott Williamson and Mark Kosters
   Copyright (c) 1996-1998 Network Solutions, Inc.

   See the file LICENSE for conditions of use and distribution.
**************************************************************** */

#include "limit.h"

#include "client_msgs.h"
#include "defines.h"
#include "log.h"
#include "main_config.h"
#include "misc.h"

/* limit_directive: allow client to request the server to allocat enough 
 * space to collect more responses than would currently be collected by
 * the server. 
 * Input:   -limit <value>
 * Response: %ok  
 *      -OR- 
 *       error messages.
 */
int 
limit_directive(str)
  char  *str;
{
  int hits;
  int argc;
  char **argv;

  log(L_LOG_DEBUG, CLIENT, "limit directive: %s", str);
  
  split_arg_list(str, &argc, &argv);

  if ( argc != 1 )
  { 
    print_error(INVALID_DIRECTIVE_PARAM,"");
    return FALSE;
  }

  hits = atoi(argv[0]);
  if ( hits < 1 || hits > get_max_hits_ceiling() )
  {
    print_error(INVALID_LIMIT, "");
    return FALSE;
  }
/*
  if (hits > get_max_hits_ceiling())
  {
    print_error(INVALID_LIMIT, "");
    return FALSE;
  }
 */
  set_hit_limit(hits);

/*   print_ok(); */
  return TRUE;
}
